#include <stdio.h>
#include <mpi.h>
#define LIM 10
int main (int argc, char *argv[]) {
  double inicio,final;
  int i,error, MyId, N;
  int buff[LIM]={10,20,30,40,50,60,70,80,90,100};
  MPI_Status status;
  MPI_Init (&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &MyId);
  MPI_Comm_size(MPI_COMM_WORLD, &N);
  if (N != 2) {
    printf(stderr,"This program only runs on TWO processors. set -np 2");
    MPI_Finalize();
    exit(1);
  }

  if (MyId == 0)
  { 
    inicio=MPI_Wtime();
    printf("time 1, process 0: %lf\n",inicio);
    MPI_Send(buff, LIM, MPI_INT, 1, 111, MPI_COMM_WORLD);
    final=MPI_Wtime();
    printf("time 2, process 0: %lf\n",final);
    printf("process %d, sent:\n", MyId);
    for (i=0;i<LIM;i++) 
      printf("{%d,%d}",MyId,buff[i]);
    printf(" \n");
    inicio=MPI_Wtime();
    printf("time 3, process 0: %lf\n",inicio);
    MPI_Recv(buff, LIM, MPI_INT, 1, 222, MPI_COMM_WORLD, &status);
    final=MPI_Wtime();
    printf("time 4,process 0: %lf\n",final);
    printf("process %d, received all messages:\n", MyId);
    for (i=0;i<LIM;i++) 
      printf("{%d,%d}",MyId,buff[i]);
    printf(" \n");

  } else
    {  
    inicio=MPI_Wtime();
    printf("time 1,process 1: %lf\n",inicio);
    MPI_Recv(buff, LIM, MPI_INT, 0, 111, MPI_COMM_WORLD, &status);
    final=MPI_Wtime();
    printf("time 2, process 1: %lf\n",final);
    printf("process %d, received :\n", MyId);
    for (i=0;i<LIM;i++) 
      printf("{%d,%d}",MyId,buff[i]);
    printf(" \n");
    for (i=0;i<LIM;i++) 
      buff[i]++; 
    inicio=MPI_Wtime();
    printf("time 3, process 1:%lf\n",inicio);
    MPI_Send(buff, LIM, MPI_INT, 0, 222, MPI_COMM_WORLD);
    final=MPI_Wtime();
    printf("time 4, process 1:%lf\n",final);
    printf("process %d, send:\n", MyId);
    for (i=0;i<LIM;i++) 
      printf("{%d,%d}",MyId,buff[i]);
    final=MPI_Wtime();
    printf(" \n");
    printf("time 5, process 1: %lf\n",final);
 }

  MPI_Finalize();
  exit(0);
}
