// Ejemplo de Comunicacion Asincrona
//
#include <stdio.h>
#include <mpi.h>
#define LIM 10
main (int argc, char *argv[]) {
  double init,final;
  int i,error, MyId, p;
  int finish,
  buff[LIM]={10,20,30,40,50,60,70,80,90,100};
  MPI_Status status[LIM];
  MPI_Request reque[LIM];
  MPI_Init (&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &MyId);
  MPI_Comm_size(MPI_COMM_WORLD, &p);
  if (p != 2) {
    fprintf("This program only runs on TWO processors. set -np 2");
    MPI_Finalize();
    exit(1);
  }
  if (MyId == 0)
  { 
    init=MPI_Wtime();
    printf("Before: %lf\n",init);
    for (i=0;i<LIM;i++) 
    {
         MPI_Isend(&(buff[i]), 1, MPI_INT, 1, 111,MPI_COMM_WORLD,&(reque[i]));
         final=MPI_Wtime();
         printf("%d,After %d, %lf\n",MyId,i,final);
    } 
    printf("Process %d, sent:\n", MyId);
    for (i=0;i<LIM;i++) 
         printf("{%d,%d}",MyId,buff[i]);
    MPI_Waitall(LIM,reque,status);
    final=MPI_Wtime();
    final=MPI_Wtime();
    printf("Process %d, end \n", MyId,final);
  } else
    {  
    init=MPI_Wtime();
    printf("%lf\n",init);
    for (i=0;i<LIM;i++) 
    {
        buff[i]=5555;  
        MPI_Irecv(&(buff[i]),1,MPI_INT, 0, 111, MPI_COMM_WORLD,&(reque[i]));
        printf("Process %d, buff[%d]= %d \n",MyId,i,buff[i]);
   }
//  
// MPI_Test(&(reque[4]),&finish,&(status[4]));
    MPI_Wait(&(reque[3]),&(status[4]));
 
           printf("Process %d, received messages \n", MyId); 

    for (i=0;i<LIM;i++) 
      printf("{%d,%d}",MyId,buff[i]);
 }
  MPI_Finalize();
  exit(0);
}
